#include <QtCore/QTimer>

#include <QtGui/QMainWindow>
#include <QtGui/QWidget>
#include <QtGui/QPaintEvent>
#include <QtGui/QPainter>
#include <QtGui/QVBoxLayout>

#define USE_QMAINWINDOW
#define CALL_WINID

#ifdef USE_QMAINWINDOW
#   define SET_MAINWINDOW_CONTENTS_MARGINS_TO_NONZERO
#else
//#   define USE_INNER_WIDGET
#   define SET_OUTERLAYOUT_CONTENTS_MARGINS_TO_ZERO
#endif

class FlashWidget : public QWidget
{
    Q_OBJECT
public:
    FlashWidget(QWidget *parent,
                const QColor& color1 = Qt::red,
                const QColor& color2 = Qt::yellow);
    void paintEvent(QPaintEvent *event);
    void setColor1(const QColor &color) { m_color1 = color; }
    void setColor2(const QColor &color) { m_color2 = color; }
private slots:
    void timerTick();
private:
    QTimer *m_timer;
    bool m_flag;
    QColor m_color1;
    QColor m_color2;
};


class MainWindow
#ifdef USE_QMAINWINDOW
:    public QMainWindow
#else
:    public QWidget
#endif
{
    Q_OBJECT
public:
    MainWindow();
private:
    void dump();
private slots:
    void timerTick();
private:
    QTimer *m_timer;
    FlashWidget *m_flash;

};

